﻿using FarPoint.Win.Spread.Design;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using C1.Win.Ribbon;
using System.Windows.Forms;
using System.Reflection;
using System.ComponentModel;
using C1.Win.C1Themes;
using System.IO;
using FarPoint.Win.Spread;
using System.Threading;

namespace SpreadDesignerDemo
{
    class Designer : FarPoint.Win.Spread.Design.DesignerMain
    {
        FpSpread spread;
        public Designer(FpSpread spread):base(spread)
        {
            this.spread=spread;
        }
        protected override void OnClosing(CancelEventArgs e)
        {
            ((this.Ribbon.ApplicationMenu.LeftPaneItems[0] as RibbonSplitButton).Items[2] as RibbonButton).PerformClick();
        }

        protected override void OnLoad(EventArgs e)
        {
            
            
            //ClearAllEvents(this, "Closing");
            
            base.OnLoad(e);

            this.Text = "我的Spread设计器";

            //隐藏右侧属性栏
            this.IsShowPropertyGridValue = false;

            //获取界面的Ribbon菜单,为C1Ribbon对象，具体操作可以参考C1控件文档
            C1Ribbon ribbon = this.Ribbon;
            
            //窗口中包含的Spread控件
            FpSpread spread=this.Spread;

            //窗体状态栏
            C1StatusBar statusbar = this.StatusBar;

            //设置类Excel主题样式
            C1Theme theme = C1ThemeController.GetThemeByName("Office2016Green", true);
            C1ThemeController.ApplyThemeToControlTree(this, theme);

            

            //增加一个保存到xxx的菜单项
            var iconset= (this.Ribbon.ApplicationMenu.LeftPaneItems[7] as RibbonButton).IconSet;
            RibbonButton savexxxbutton = new RibbonButton() { Text = "保存为xxx(&S)"};
            savexxxbutton.IconSet.Clear();
            savexxxbutton.IconSet.Add(iconset[0]);
            savexxxbutton.Click += Savebutton_Click;
            this.Ribbon.ApplicationMenu.LeftPaneItems.Insert(7, savexxxbutton);

            //删除菜单下方“输出”按钮
            this.Ribbon.ApplicationMenu.BottomPaneItems.Remove(this.Ribbon.ApplicationMenu.BottomPaneItems[0]);



          
        }


        private void Savebutton_Click(object sender, EventArgs e)
        {
            this.Spread.Sheets.Count=9;
            int i = 0;
            foreach (string file in new string[] { @"D:\Projects\03319_0.xml", @"D:\Projects\03319_3.xml", @"D:\Projects\03319_6.xml", })
            {
                
                FpSpread fp = new FpSpread();

                fp.Open(file);

                this.Spread.Sheets[i] =fp.Sheets[0].Clone();
                this.Spread.Sheets[i+1] = fp.Sheets[1].Clone();
                this.Spread.Sheets[i+2] = fp.Sheets[2].Clone();
                i += 3;
            }
            //SaveFileDialog s = new SaveFileDialog();
            //s.Filter = "专用文件(*.xxx)|*.xxx";
            //if (s.ShowDialog() == DialogResult.OK)
            //{
            //    this.Spread.SaveExcel(s.FileName);
            //}
        }


        #region 清除事件绑定的函数
        /// <summary>
        /// 清除事件绑定的函数
        /// </summary>
        /// <param name="objectHasEvents">拥有事件的实例</param>
        /// <param name="eventName">事件名称</param>
        public static void ClearAllEvents(object objectHasEvents, string eventName)
        {
            if (objectHasEvents == null)
            {
                return;
            }
            try
            {
                EventInfo[] events = objectHasEvents.GetType().GetEvents(BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance);
                if (events == null || events.Length < 1)
                {
                    return;
                }
                for (int i = 0; i < events.Length; i++)
                {
                    EventInfo ei = events[i];
                    if (ei.Name == eventName)
                    {
                        FieldInfo fi = ei.DeclaringType.GetField(eventName, BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance);
                        if (fi != null)
                        {
                            fi.SetValue(objectHasEvents, null);
                        }
                        break;
                    }
                }
            }
            catch
            {
            }
        }
        #endregion
    }

}
